Print Friendly

# Class YAHOO.util.Element

Package: | YAHOO.util
Class: | Element
Extends: | Object
Subclasses: | Tab
Defined In: | tabview.js

Element provides an interface to an HTMLElement's attributes and common methods. Other commonly used attributes are added as well. @uses YAHOO.util.AttributeProvider

## Public Properties

Property | Defined By
--- | ---
| DOM_EVENTS : Object | Element
Dom events supported by the Element instance.
| register : HTMLElement | Element
The HTMLElement the Element instance refers to. @config element

## Public Methods

Method | Defined By
--- | ---
| Element(`el {HTMLElement`, `Object map`) | Element
| addClass(`String className`) : void | Element
Wrapper for Dom method.
| addListener(`String type`, `Function fn`, `Any obj`, `Object scope`) : void | Element
Adds a listener for the given event. These may be DOM or customEvent listeners. Any event that is fired via fireEve...
| appendChild(`Boolean deep`) : void | Element
Wrapper for HTMLElement method.
| appendTo(`HTMLElement |`, `HTMLElement |`) : void | Element
Appends the HTMLElement into either the supplied parentNode.
| fireQueue() : void | Element
Apply any queued set calls.
| getElementsByClassName(`String className`, [`String tag`]) : Array | Element
Wrapper for Dom method.
| getElementsByTagName(`String tag`) : void | Element
Wrapper for HTMLElement method.
| getStyle(`String property`) : String | Element
Wrapper for Dom method.
| hasChildNodes() : Boolean | Element
Wrapper for HTMLElement method.
| hasClass(`String className`) : Boolean | Element
Wrapper for Dom method.
| initAttributes(`Object map`) : void | Element
Registers Element specific attributes.
| insertBefore(`HTMLElement element`, `HTMLElement before`) : void | Element
Wrapper for HTMLElement method.
| on(`String type`, `Function fn`, `Any obj`, `Object scope`) : void | Element
Alias for addListener
| removeChild(`HTMLElement child`) : void | Element
Wrapper for HTMLElement method.
| removeClass(`String className`) : void | Element
Wrapper for Dom method.
| removeListener(`String type`, `Function fn`) : void | Element
Remove an event listener
| replaceChild(`HTMLElement newNode`, `HTMLElement oldNode`) : void | Element
Wrapper for HTMLElement method.
| replaceClass(`String oldClassName`, `String newClassName`) : void | Element
Wrapper for Dom method.
| setStyle(`String property`, `String value`) : void | Element
Wrapper for Dom method.

## Public Events

Event | Defined By
--- | ---
| available : () | Element
Fires when the Element's HTMLElement can be retrieved by Id. See: Element.addListener Event fields: <String> ty...

## Property Details

### DOM_EVENTS

`public Object DOM_EVENTS`
Dom events supported by the Element instance.
This property is defined by Element.

### register

`public HTMLElement register`
The HTMLElement the Element instance refers to. @config element
This property is defined by Element.

## Constructor Details

### Element

`public function Element(`el {HTMLElement`, `Object map`)`
Parameters:

- `{HTMLElement` : el
  | String} The html element that represents the Element.
- `map` : Object
  A key-value map of initial config names and values

## Method Details

### addClass

`public function addClass(`String className`)`
Wrapper for Dom method.
Parameters:

- `className` : String
  The className to add

Returns:

- `void`

This method is defined by Element.

### addListener

`public function addListener(`String type`, `Function fn`, `Any obj`, `Object scope`)`
Adds a listener for the given event. These may be DOM or customEvent listeners. Any event that is fired via fireEvent can be listened for. All handlers receive an event object.
Parameters:

- `type` : String
  The name of the event to listen for
- `fn` : Function
  The handler to call when the event fires
- `obj` : Any
  A variable to pass to the handler
- `scope` : Object
  The object to use for the scope of the handler

Returns:

- `void`

This method is defined by Element.

### appendChild

`public function appendChild(`Boolean deep`)`
Wrapper for HTMLElement method.
Parameters:

- `deep` : Boolean
  Whether or not to do a deep clone

Returns:

- `void`

This method is defined by Element.

### appendTo

`public function appendTo(`HTMLElement |`, `HTMLElement |`)`
Appends the HTMLElement into either the supplied parentNode.
Parameters:

- `|` : HTMLElement
  Element} parentNode The node to append to
- `|` : HTMLElement
  Element} before An optional node to insert before

Returns:

- `void`

This method is defined by Element.

### fireQueue

`public function fireQueue()`
Apply any queued set calls.
Parameters:

- None.

Returns:

- `void`

This method is defined by Element.

### getElementsByClassName

`public function getElementsByClassName(`String className`, [`String tag`])`
Wrapper for Dom method.
Parameters:

- `className` : String
  The className to collect
- `tag` : String
  (optional) The tag to use in conjunction with class name

Returns:

- `Array`
  Array of HTMLElements

This method is defined by Element.

### getElementsByTagName

`public function getElementsByTagName(`String tag`)`
Wrapper for HTMLElement method.
Parameters:

- `tag` : String
  The tagName to collect

Returns:

- `void`

This method is defined by Element.

### getStyle

`public function getStyle(`String property`)`
Wrapper for Dom method.
Parameters:

- `property` : String
  The style property to retrieve

Returns:

- `String`
  The current value of the property

This method is defined by Element.

### hasChildNodes

`public function hasChildNodes()`
Wrapper for HTMLElement method.
Parameters:

- None.

Returns:

- `Boolean`
  Whether or not the element has childNodes

This method is defined by Element.

### hasClass

`public function hasClass(`String className`)`
Wrapper for Dom method.
Parameters:

- `className` : String
  The className to add

Returns:

- `Boolean`
  Whether or not the element has the class name

This method is defined by Element.

### initAttributes

`public function initAttributes(`Object map`)`
Registers Element specific attributes.
Parameters:

- `map` : Object
  A key-value map of initial attribute configs

Returns:

- `void`

This method is defined by Element.

### insertBefore

`public function insertBefore(`HTMLElement element`, `HTMLElement before`)`
Wrapper for HTMLElement method.
Parameters:

- `element` : HTMLElement
  The HTMLElement to insert
- `before` : HTMLElement
  The HTMLElement to insert the element before.

Returns:

- `void`

This method is defined by Element.

### on

`public function on(`String type`, `Function fn`, `Any obj`, `Object scope`)`
Alias for addListener
Parameters:

- `type` : String
  The name of the event to listen for
- `fn` : Function
  The function call when the event fires
- `obj` : Any
  A variable to pass to the handler
- `scope` : Object
  The object to use for the scope of the handler

Returns:

- `void`

This method is defined by Element.

### removeChild

`public function removeChild(`HTMLElement child`)`
Wrapper for HTMLElement method.
Parameters:

- `child` : HTMLElement
  The HTMLElement to remove

Returns:

- `void`

This method is defined by Element.

### removeClass

`public function removeClass(`String className`)`
Wrapper for Dom method.
Parameters:

- `className` : String
  The className to remove

Returns:

- `void`

This method is defined by Element.

### removeListener

`public function removeListener(`String type`, `Function fn`)`
Remove an event listener
Parameters:

- `type` : String
  The name of the event to listen for
- `fn` : Function
  The function call when the event fires

Returns:

- `void`

This method is defined by Element.

### replaceChild

`public function replaceChild(`HTMLElement newNode`, `HTMLElement oldNode`)`
Wrapper for HTMLElement method.
Parameters:

- `newNode` : HTMLElement
  The HTMLElement to insert
- `oldNode` : HTMLElement
  The HTMLElement to replace

Returns:

- `void`

This method is defined by Element.

### replaceClass

`public function replaceClass(`String oldClassName`, `String newClassName`)`
Wrapper for Dom method.
Parameters:

- `oldClassName` : String
  The className to replace
- `newClassName` : String
  The className to add

Returns:

- `void`

This method is defined by Element.

### setStyle

`public function setStyle(`String property`, `String value`)`
Wrapper for Dom method.
Parameters:

- `property` : String
  The style property to set
- `value` : String
  The value to apply to the style property

Returns:

- `void`

This method is defined by Element.

## Event Details

### available

`public event available`
Fires when the Element's HTMLElement can be retrieved by Id.

See: Element.addListener

Event fields:
`<String> type` available
`<HTMLElement> target` the HTMLElement bound to this Element instance

Usage:
`var handler = function(e) {var target = e.target};
myTabs.addListener('available', handler);`

Subscribers will be called with the following parameters:

- None.

This event is defined by Element.

Copyright © 2006 Jack Slocum. All rights reserved.